package domaine;

import java.math.RoundingMode;
import java.text.NumberFormat;

public class BankAccount {
	private int accountNumber;// Numro du compte.
	private double balance;// solde = montant disponible sur le compte.
	private NumberFormat format = null;

	// Constructeur d'un CompteBancaire.
	public BankAccount(int number) {
		this.accountNumber = number;
		this.balance=0.0;
	}

	// Mthode qui permet de dposer de l'argent sur le compte.
	public void deposit(double amount) throws Exception {
		if(amount > 0.0) {
			balance += amount;// On ajoute la somme dpose au solde.
		} else {
			throw new Exception("Dpt d'une valeur ngative impossible (compte : " + accountNumber + " depot de " + amount + ").");
		}
	}

	// Mthode qui permet de retirer de l'argent sur le compte.
	public void withdraw(double amount) throws Exception {
		if(amount > 0.0) {
			if(balance >= amount) {
				balance -= amount;// On retranche du solde la somme retire.
			} else {
				throw new Exception("La banque n'autorise pas de dcouvert (compte : " + accountNumber+" solde : " + balance + " retrait de " + amount + ").");
			}
		} else {
			throw new Exception("Retrait d'une valeur ngative impossible (compte : " + accountNumber + " retrait de " + amount + ").");
		}
	}

	public double balance() {
		return balance;
	}

	public int number() {
		return accountNumber;
	}

	public String toString() {
		if (format == null) {
			format = NumberFormat.getNumberInstance();
			format.setMinimumIntegerDigits(1);
			format.setMaximumIntegerDigits(4);
			format.setGroupingUsed(false);
			format.setMinimumFractionDigits(2);
			format.setMaximumFractionDigits(2);
			format.setRoundingMode(RoundingMode.HALF_UP);
		}
		return "numero : " + accountNumber + " solde : " + format.format(balance);
	}
}
