package domaine;

public class BankAccountProxy {
	private BankAccount account;
	public BankAccountProxy(int accountNumber) {
		//on passe les paramtres de construction de l'objet du mandat
		//le mandataire construit l'objet du mandat
		account = new BankAccount(accountNumber);
		Log.getInstance().write("Ouverture du compte " + account.number() + ".");
	}
	public void deposit(double amount) throws Exception {
		try {
			Log.getInstance().write("Dpt de " + amount + " sur le compte " + account.number() + ".");
			account.deposit(amount);
		} catch (Exception e) {
			Log.getInstance().write("/!\\ "+e.getMessage());
		}
	}
	public void withdraw(double amount) throws Exception {
		try {
			Log.getInstance().write("Retrait de " + amount + " sur le compte " + account.number() + ".");
			account.withdraw(amount);
		} catch (Exception e) {
			Log.getInstance().write("/!\\ " + e.getMessage());
		}
	}
	public int number() {
		return account.number();
	}
	public double balance() {
		Log.getInstance().write("Consultation du solde du compte " + account.number() + ".");
		return account.balance();
	}
	public String toString() {
		return account.toString();
	}
	//pas d'autres mthodes publiques que celles qui sont dfinies
	//pour l'objet du mandat
}
