package domaine;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

public class Log {
	private static Log uniqueInstance;// Stockage de l'unique instance de cette classe.
	private static DateFormat df = null;
	private class Record {
		String when;
		String what;
		Record(String msg) {
			// On mmorise la date du message.
			Date d = new Date();
			if (df == null) df = new SimpleDateFormat("dd/MM/yy HH'h'mm");
			when = df.format(d);
			what = msg;
		}
		public String toString() {
			return "[" + when + "]" + what;
		}
	}
	private List<Record> content;// collection de tous les articles du journal.

	// Constructeur priv (donc inaccessible  l'extrieur de la classe).
	private Log() {
		content = new LinkedList<Record>();
	}

	// Mthode statique qui sert de pseudo-constructeur (utilisation du mot clef "synchronized" pour le multithread).
	public static synchronized Log getInstance() {
		if(uniqueInstance==null) {
			uniqueInstance = new Log();
		}
		return uniqueInstance;
	}

	// Mthode qui permet d'ajouter un message au journal.
	public void write(String msg) {
		content.add(new Record(msg));
	}

	public String toString() {
		StringBuffer text = new StringBuffer();
		Iterator<Record> it = content.iterator();
		while (it.hasNext()) {
			text.append(it.next() + "\n");
		}
		return text.toString();
	}
}
